/*******************************************************************************
 * Copyright (c) 2009 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.e4.languages.javascript.jsdi;

import java.util.List;

public interface PropertiesReference extends Value {
	/**
	 * The underlying value for this property
	 * 
	 * @return the underlying value for this objects
	 */
	public Value getValue(Property property);

	/**
	 * The properties for this Scriptable
	 * 
	 * @return the list of Property objects available for this Property object
	 */
	public List properties();
}
